//
// FernsehWidget
// Von Pascal Pfiffner und Sebastian Krauß
//


/*
 *********************************************
 **	 all die GUI-spielereien und die Prefs	**
 *********************************************
 */



/*
 *********
 * Prefs *
 *********
 */

function savePrefs() {
	//alert("savePrefs() called");
	if(window.widget) {
		
		// basic options
		widget.setPreferenceForKey(getListingDay(), "day");
		widget.setPreferenceForKey(getListingTime(), "hour");
		
		var optval = (document.getElementById("kurzInfoStandard").checked ? "1" : "0");
		widget.setPreferenceForKey(optval, "showShortDesc");
		
		var opt = getObj("mainFontSize");
		optval = opt.options[opt.selectedIndex].value;
		optval = ((optval > 8) && (optval < 38)) ? optval : 14;
		widget.setPreferenceForKey(optval, "mainFontSize");
		setMainFontSize();
		
		// save default group and num channels to display
		widget.setPreferenceForKey(getDefaultChannelGroup(), "defaultChannelGroup");
		widget.setPreferenceForKey(getNumberOfEntriesToDisplay(), "numEntriesPerPage");
		
		widget.setPreferenceForKey(getNumDaysToPrecache(), "numDaysToPrecache");
		numDaysToPrecache = getNumDaysToPrecache();
		
		opt = document.getElementById("erinnerung");
		optval = opt.options[opt.selectedIndex].value;
		widget.setPreferenceForKey(optval, "reminder");
		
		opt = document.getElementById("movieDatabase");
		optval = opt.options[opt.selectedIndex].value;
		widget.setPreferenceForKey(optval, "movieDatabase");
		
		// save channel groupings
		saveChannelGroupings();
		
		// save filters (if necessary)
		if(filtersHaveChanged) {
			saveFilters();
			//if (debugMode) alert(numberOfHitsForFilters() + " treffer fuer die filter");
			document.getElementById('filtercount').style.display = 'none';
			setTimeout("updateFilterBadge();", 500);
			debug("jo die filter sind anders");
			filtersHaveChanged = false;
		}
		
		// save enabled EyeTV or FormacDVB support
		optval = ((document.getElementById("eyetvSupport").checked && (FernsehPlugin && FernsehPlugin.canUseEyeTV())) ? "1" : "0");
		widget.setPreferenceForKey(optval, "eyetvEnabled");
		eyetvEnabled = optval;
		optval = ((document.getElementById("formacSupport").checked && (eyetvEnabled != 1) && (FernsehPlugin && FernsehPlugin.canUseFormac())) ? "1" : "0");
		widget.setPreferenceForKey(optval, "formacEnabled");
		useFormac = optval;
		
		optval = (document.getElementById("growlSupport").checked ? "1" : "0");
		widget.setPreferenceForKey(optval, "growlSupport");
		growlSupport = optval;

		
		if(FernsehPlugin && FernsehPlugin.canUseGrowlNotification())
			FernsehPlugin.setUsesGrowlNotification(document.getElementById("growlSupport").checked);
		
		if((document.getElementById("eyetv_form").style.display == "block") && (document.getElementById("eyetv_senderlist_fix").style.display == "block"))
			saveEyeTVChannelAssigns();
	}
	// copy the prefs, preparing for a new identifier
	widget.system("/bin/cp ~/Library/Preferences/widget-de.sebastian-krauss.widget.Fernsehen.plist ~/Library/Preferences/widget-de.widgetschmie.widget.Fernsehen.plist", null);
	
	hidePrefs();
}


function saveEyeTVChannelAssigns() {

	var selects = document.getElementById("eyetv_form").elements;
	var tvtodayname, listname, selvalue;

	eyetvChannels = new Array();
	for (i = 0; i < selects.length; i++)
	{
		selector = selects[i];
		// skip non-select-menu-childs
		if(selector.nodeName != "SELECT")
			continue;
		selvalue = selector.options[selector.selectedIndex].value;
		if(selvalue == "")
			continue;
		tvtodayname = selector.name;
		tvtodayname = tvtodayname.substr(13, tvtodayname.length-13);
		listname = tvtodayname.replace(/_/, " ");
		eyetvChannels[listname] = selvalue;
	}
	var serChannels = "";
	for (var channel in eyetvChannels)
	{
		serChannels += channel + ">>>>" + eyetvChannels[channel] + "////"
	}
	
	if(window.widget)
		widget.setPreferenceForKey(serChannels, "eyetvChannels");
	eyetvChannels = getEyeTVChannelAssigns();
	//alert("saved EyeTV Channels: " + serChannels);
}


function showPrefs() {
	if (0.98 > document.getElementById('flip').opacity) return;
	var now = new Date();
	var today = now.getDate();
	var elem = document.getElementById('ztag');
	
	for (i = 3; i < MAX_POSSIBLE_DAYS_CACHE+2; i++)
	{
		var otherDay = new Date();
		otherDay.setTime(now.getTime() + ((i -1) * 86400000));
		elem.options[i].text = printableDate(otherDay);
	}

	var front = document.getElementById("frontDiv");
	var back = document.getElementById("prefDiv");
	
	if(window.widget)
		widget.prepareForTransition("ToBack");
	
	hideDrawer();			
	front.style.display = "none";
	back.style.display = "block";
		
	if(window.widget)
		setTimeout("widget.performTransition();", 0);	 
}

function hidePrefs() {

	var front = document.getElementById("frontDiv");
	var back = document.getElementById("prefDiv");

	if(window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display = "block";
	back.style.display = "none";

	if(window.widget)
		setTimeout("widget.performTransition();", 0);
	setTimeout("redrawElapsed();",1);
	setTimeout("updateTVListing();",2);
}


// changes the main font size.
function setMainFontSize() {
	var mainFontSize = 14;
	if(window.widget)
		mainFontSize = widget.preferenceForKey("mainFontSize");
	
	var body = document.getElementsByTagName('body');
	body[0].setAttribute("style", "font-size:" + mainFontSize + "px");
}


function toggleEyeTVSupport()
{
	if (!document.getElementById('eyetvSupport').disabled)
	{
		document.getElementById('eyetvSupport').checked = document.getElementById('eyetvSupport').checked ? false : true;
		eyeTVToggled();
	}
}

function eyeTVToggled() {
	// if eyeTV is activated
	if(document.getElementById("eyetvSupport").checked) {
		weUseEyeTV();
	}
	else if(FernsehPlugin && FernsehPlugin.canUseFormac()) {
		document.getElementById("formacSupport").disabled = false;
	}
	setTimeout("checkEyeTV()", 100);
}

function weUseEyeTV() {
	document.getElementById("formacSupport").checked = false;
	document.getElementById("formacSupport").disabled = true;
	document.getElementById("eyetv_form_tab").lastChild.previousSibling.innerHTML = "EyeTV";
	document.getElementById("startEyeTVOrFormac").innerHTML = "EyeTV";
	FernsehPlugin.setEyeTVEnabled(true);
	eyetvEnabled = 1;
	useFormac = 0;
	appName = FernsehPlugin.appNameForEyeTV();
}

function useFormacTextClicked()
{
	if (!document.getElementById("formacSupport").disabled)
	{
		document.getElementById("formacSupport").checked = document.getElementById("formacSupport").checked ? false : true;
		useFormacToggled();
	}
}

function useFormacToggled() {
	// if Formac DVB is activated
	if(document.getElementById("formacSupport").checked) {
		weUseFormac();
	}
	else if(FernsehPlugin && FernsehPlugin.canUseEyeTV()) {
		document.getElementById("eyetvSupport").disabled = false;
	}
	setTimeout("checkEyeTV()", 100);
}

function weUseFormac() {
	document.getElementById("eyetvSupport").checked = false;
	document.getElementById("eyetvSupport").disabled = true;
	document.getElementById("eyetv_form_tab").lastChild.previousSibling.innerHTML = "Formac";
	document.getElementById("startEyeTVOrFormac").innerHTML = "FormacDVB";
	FernsehPlugin.setFormacEnabled(true);
	eyetvEnabled = 0;
	useFormac = 1;
	appName = FernsehPlugin.appNameForFormac();
}

function checkEyeTV()
{
	if (FernsehPlugin && ((undefined != eyetvEnabled) && (eyetvEnabled == 1))) FernsehPlugin.setEyeTVEnabled(document.getElementById('eyetvSupport').checked);
	if (FernsehPlugin && ((undefined != useFormac) && (useFormac == 1))) FernsehPlugin.setFormacEnabled(document.getElementById('formacSupport').checked);
	//if (FernsehPlugin && ((undefined != useFormac) && (useFormac == 1))) FernsehPlugin.setFormacEnabled(true);
	if (!eyeTVIsRunning()) return;
	if (!document.getElementById('eyetvSupport').checked && ((undefined != eyetvEnabled) && (eyetvEnabled == 1))) return;
	if (!document.getElementById('formacSupport').checked && ((undefined != useFormac) && (useFormac == 1))) return;
	var numAssigns = 0;
	for (var channel in eyetvChannels)
	{
		numAssigns++;
	}
	if (document.getElementById('eyetv_assign_ARD').options.length == 0) setupEyeTVChannelAssigns();
	if (numAssigns == 0) setupEyeTVChannelAssigns();
}

var availChannels;
function setupEyeTVChannelAssigns() {
	if (!document.getElementById('eyetvSupport').checked && ((undefined != eyetvEnabled) && (eyetvEnabled == 1))) return;
	if (!document.getElementById('formacSupport').checked && ((undefined != useFormac) && (useFormac == 1))) return;
	
	// count eyeTV-Channels
	var numAssigns = 0;
	for (var channel in eyetvChannels)
	{
		numAssigns++;
	}
	availChannels = getEyeTVChannels();
	
	var selects = document.getElementById("eyetv_form").elements;
	var guesschannels, tvtodayname;
	
	// if no channel is assigned; guess
	if(numAssigns == 0)
		guessAllEyeTVChannels();
	
	// Set up the select-menu (only set up ONE element for now)
	//if (document.getElementById("eyetv_assign_ARD").options.length == 0)
	//{
		
		for (i = 0; i < selects.length; i++)
		{
			selector = selects[i];
			
			// skip non-select-menu-childs
			if(selector.nodeName != "SELECT")
				continue;
			
			// empty element (just to be sure)
			while(null != selector.lastChild)
				selector.removeChild(selector.lastChild);
			
			var channel_name = selector.name.substr(13, selector.name.length - 13);
			var channelname = channel_name.replace(/_/g, " ");
			var element = document.createElement("option");
			
			// add the only element
			if(eyetvChannels[channelname]) {
				element.value = eyetvChannels[channelname];
				element.innerHTML = eyetvChannels[channelname];
				selector.appendChild(element);
			}
			else {
				element.value = '';
				element.innerHTML = "* zuweisen...";
				selector.appendChild(element);
			}
			
			selector.setAttribute("onmousedown", "createEyeTVAssignMenu('" + channel_name + "')");
		}
	//}
}

// takes the tvtoday channelname as argument
function createEyeTVAssignMenu(name) {
	if(!name)
		return;
	
	var selector = document.getElementById("eyetv_form").elements["eyetv_assign_" + name];
	selector.options[0].innerHTML = "lade Sender...";
	while(selector.options.length > 1)
		selector.removeChild(selector.options[1]);
	
	// create a list of all channels
	selector.appendChild(document.createElement("option"));
	selector.options[1].value = "";
	selector.options[1].innerHTML = "* Kein Sender";
	selector.appendChild(document.createElement("option"));
	selector.options[2].value = "";
	selector.options[2].innerHTML = "";
	
	// add all eyeTV-channels
	for(i = 0; i < availChannels.length; i++) {
		var elem = document.createElement("option");
		elem.value = availChannels[i];
		elem.innerHTML = availChannels[i];
		
		if(eyetvChannels[name.replace(/_/g, " ")] == availChannels[i]) {
			//elem.innerHTML = "* " + availChannels[i];
			elem.selected = true;
		}
		
		selector.appendChild(elem);
	}
	
	// clean up
	selector.removeChild(selector.options[0]);
	selector.setAttribute("onchange", "removeEyeTVAssignMenu('" + name + "')");
}

// takes the tvtoday channelname as argument
function removeEyeTVAssignMenu(name) {
	if(!name)
		return;
	
	var selector = document.getElementById("eyetv_form").elements["eyetv_assign_" + name];
	var selected_name;
	
	// remove all but the selected one
	for(i = selector.options.length - 1; i >= 0; i--) {
		if(selector.options[i].selected)
			selected_name = selector.options[i].value;
		if(null != selector.options[i])
			selector.removeChild(selector.options[i]);
	}
	
	// add again element to choose "reassign channels"
	var element = document.createElement("option");
	element.value = selected_name;
	element.innerHTML = selected_name;
	element.selected = true;
	var element2 = document.createElement("option");
	element2.value = '';
	element2.innerHTML = "neu zuweisen...";
	
	selector.appendChild(element);
	selector.appendChild(element2);
	selector.setAttribute("onchange", "checkToCreateEyeTVAssignMenu('" + name + "')");
}

function guessAllEyeTVChannels() {
	var selects = new Array();
	var tmpselects = document.getElementById("eyetv_senderlist_scroll").childNodes;
	var guesschannels = new Array();
	var guessname;
	var guessIdx;
	
	// get all select-elements into one array
	for (i = 0; i < tmpselects.length; i++)
	{
		if(tmpselects[i].nodeName != "SELECT")
			continue;
		
		selector = tmpselects[i];
		
		guessname = selector.name.toLowerCase();
		guessname = guessname.substr(13, guessname.length-13);
		guessname = guessname.replace(/_/, "");
		
		guesschannels.push(guessname);
		selects.push(tmpselects[i]);
	}
	//alert(guesschannels + '\n' + availChannels + '\n');
	
	for (l = 0; l < availChannels.length; l++)
	{
		if (undefined == availChannels[l]) continue;
		
		guessIdx = guessIndexForChannel(guesschannels, availChannels[l]);
		if(guessIdx != -1) {
			var selname = selects[guessIdx].name;
			eyetvChannels[selname.substr(13,  + selname.length - 13).replace(/_/g, " ")] = availChannels[l];
			//alert("guessed " + selname.substr(13,  + selname.length - 13).replace(/_/g, " ") + " > " + availChannels[l]);
		}
	}
}


function switchToPrefSection(div_id) {
	var poss = document.getElementById('prefTabBar').childNodes;
	var chief;
	
	for(i = 0; i < poss.length; i++) {
		if(poss[i].nodeName == "A") {
			chief = poss[i].id.substring(0, (poss[i].id.length - 4));
			//alert('style ' + poss[i].style.opacity);
			document.getElementById(chief).style.display = (chief == div_id) ? 'block' : 'none';
			poss[i].style.opacity = (chief == div_id) ? '1.0' : '0.6';
		}
	}
	
	if(div_id == 'eyetv_form')
	{
		if (FernsehPlugin.canUseEyeTV() || FernsehPlugin.canUseFormac())
		{
			if(eyeTVIsRunning()) {
				document.getElementById('eyetv_start_button').style.display = "none";
				document.getElementById('eyetv_not_started_warning').style.display = "none";
				document.getElementById('eyetv_start_hint').style.display = "none";
				document.getElementById('eyetv_senderlist_fix').style.display = "block";
				
				setupEyeTVChannelAssigns();
			}
			else {
				document.getElementById('eyetv_start_button').style.display = "block";
				document.getElementById('eyetv_not_started_warning').style.display = "block";
				document.getElementById('eyetv_start_hint').style.display = "block";
				document.getElementById('eyetv_senderlist_fix').style.display = "none";
				
				document.getElementById('eyetv_not_started_warning').innerHTML = eyeTVChannelsAssigned() ? "Sender bereits zugewiesen" : "Sender nicht zugewiesen";
			}
		} else {
			// can't use eyetv
			document.getElementById('eyetv_start_button').style.display = "none";
			document.getElementById('eyetv_not_started_warning').style.display = "none";
			document.getElementById('eyetv_start_hint').style.display = "none";
			document.getElementById('eyetv_senderlist_fix').style.display = "none";
		}
	}
	else if(document.getElementById('eyetv_assign_ARD').options.length > 0)		// nicht vielleicht lieber wenn der haken gesetzt ist?
		saveEyeTVChannelAssigns();
}


function showChannelInGroup(channel, name, parent) {
	var parentdiv = document.getElementById(parent);
	if(!parentdiv)
		return;
	
	// create element and add it to the div
	var div = document.createElement("div");
	div.setAttribute("title", channel);
	div.setAttribute("class", "divDrag_item");
	div.setAttribute("onmouseover", "divDragHover(event)");
	
	var img = document.createElement("img");
	img.setAttribute("class", "removeknob");
	img.setAttribute("src", "Images/removeKnob.png");
	img.setAttribute("alt", "x");
	img.setAttribute("onclick", "removeChannelFromGroup(this.parentNode)");
	
	//var text = document.createTextNode(name);
	var text = document.createElement("span");
	text.innerHTML = name;
	text.setAttribute("class", "divDrag_titlespan");
	text.setAttribute("onmousedown", "divDragDown(this.parentNode, event)");
	
	div.appendChild(img);
	div.appendChild(text);
	parentdiv.appendChild(div);
}

function addChannelToGroup(channel, name, parent) {
	var parentdiv = document.getElementById(parent);
	if(!channel || !parentdiv)
		return;
	
	// create element and add it to the div
	if((parent == "channels_main") && (channels_main[channel] == undefined)) {
		showChannelInGroup(channel, name, parent);
		channels_main[channel] = name;
	}
	else if((parent == "channels_two") && (channels_two[channel] == undefined)) {
		showChannelInGroup(channel, name, parent);
		channels_two[channel] = name;
	}
}

var channelelementToRemove = null;
function removeChannelFromGroup(obj) {
	var parent = obj.parentNode;
	if(!parent)
		return;
	
	// show poof
	var event = window.event;
	showPoof(event.x, event.y);
	
	// remove it (from the hash, too)
	channelelementToRemove = obj;
	obj.style.opacity = 0;
	
	if(parent.id == "channels_main") {
		channels_main = removeKeyFromHash(obj.title, channels_main);
		setTimeout("document.getElementById('channels_main').removeChild(channelelementToRemove)", 500);
	}
	else if(parent.id == "channels_two") {
		channels_two = removeKeyFromHash(obj.title, channels_two);
		setTimeout("document.getElementById('channels_two').removeChild(channelelementToRemove)", 500);
	}
	setTimeout("channelelementToRemove = null;", 520);
}

function saveChannelGroupings() {
	// main channels
	var nodes = document.getElementById("channels_main").childNodes;
	var prefstring = '';
	channels_main = { };
	for(var m = 0; m < nodes.length; m++) {
		if(nodes[m].getAttribute("class") == "divDrag_item") {
			var name = nodes[m].lastChild.innerHTML;
			var channel = nodes[m].title;
			if(!channels_main[channel]) {
				prefstring += channel + ":" + name + "|";
				channels_main[channel] = name;
			}
		}
	}
	widget.setPreferenceForKey(prefstring, "channels_main");
	
	// save new channel-order: second channels
	var nodes = document.getElementById("channels_two").childNodes;
	var prefstring = '';
	channels_two = { };
	for(var n = 0; n < nodes.length; n++) {
		if(nodes[n].getAttribute("class") == "divDrag_item") {
			var name = nodes[n].lastChild.innerHTML;
			var channel = nodes[n].title;
			if(!channels_two[name]) {
				prefstring += channel + ":" + name + "|";
				channels_two[channel] = name;
			}
		}
	}
	widget.setPreferenceForKey(prefstring, "channels_two");
}



/*******************************
	 Dragging divs around
 *******************************/
 
var divDrag = {
			parent:null,
			oldParent:null,
			parentSwitched:false,
			element:null,
			duplicateChannel:null,
			lastYPos:0,
			topOffset:0,
			topOffsetChannels:83,
			topOffsetFilters:70,
			lastClickedTime:null
		};

function divDragDown(element, event) {
	// check for a doublecklick
	var now = (new Date()).getTime();
	if(divDrag.lastClickedTime && (divDrag.lastClickedTime + 400 > now))
		return;
	
	divDrag.lastClickedTime = now;
	
	divDrag.parent = element.parentNode;
	var topoffset = (divDrag.parent == document.getElementById("filters")) ? divDrag.topOffsetFilters : divDrag.topOffsetChannels;
	divDrag.topOffset = Math.abs(topoffset - divDrag.parent.scrollTop);
	var x = event.x;
	var y = event.y - divDrag.topOffset;
	
	// add a placeholder
	var placeholder = document.createElement("div");
	placeholder.setAttribute("class", "divDrag_empty");
	divDrag.parent.insertBefore(placeholder, element);
	
	// mark current parent (only if not in filters-tab)
	if(divDrag.parent != document.getElementById("filters"))
		divDrag.parent.parentNode.setAttribute("class", "channels_assigned_fix hovermark");
	
	// we remove the channel from the channelgroup-hash to control dropping
	if(divDrag.parent.id == "channels_main")
		channels_main = removeKeyFromHash(element.title, channels_main);
	else if(divDrag.parent.id == "channels_two")
		channels_two = removeKeyFromHash(element.title, channels_two);
	
	// make the element moveable and add the eventlisteners
	divDrag.element = element;
	element.setAttribute("class", "divDrag_drag");
	element.setAttribute("style", "top:" + y + "px;");
	
	document.addEventListener("mousemove", divDragMove, true);
	document.addEventListener("mouseup", divDragUp, true);
	event.stopPropagation();
	event.preventDefault();
}

function divDragMove(event) {
	var element = divDrag.element;
	var my_y = event.y - divDrag.topOffset;
	
	element.style.top = my_y + "px";

	event.stopPropagation();
	event.preventDefault();
}

function divDragUp(event) {
	var element = divDrag.element;
	
	// insert element before current placeholder (will be removed later, a simple replaceChild() kept the Widget crashing when switching parent)
	var nodes = divDrag.parent.childNodes;
	var placeholder_found = false;
	for(var i = 0; i < nodes.length; i++) {
		if((nodes[i].nodeName == "DIV") && (nodes[i].getAttribute("class") == "divDrag_empty")) {
			divDrag.parent.insertBefore(element, nodes[i]);
			placeholder_found = true;
			break;
		}
	}
	
	// if no placeholder was found, put element at the end of the list
	if(!placeholder_found) {
		divDrag.parent.appendChild(element);
	}
	
	// clean up
	divDragRemovePlaceholders();
		
	element.setAttribute("class", "divDrag_item");
	element.removeAttribute("style");
	if(divDrag.parent != document.getElementById("filters"))
		divDrag.parent.parentNode.setAttribute("class", "channels_assigned_fix");
	
	// we add the channel to the channelgroup-hash (to control dropping)
	if(divDrag.parent.id == "channels_main")
		channels_main[element.title] = element.lastChild.innerHTML;
	else if(divDrag.parent.id == "channels_two")
		channels_two[element.title] = element.lastChild.innerHTML;
	
	// clean up
	document.removeEventListener("mousemove", divDragMove, true);
	document.removeEventListener("mouseup", divDragUp, true);
	event.stopPropagation();
	event.preventDefault();
	
	divDrag.parent = null;
	divDrag.oldParent = null;
	divDrag.parentSwitched = false;
	divDrag.element = null;
	divDrag.lastYPos = 0;
	divDrag.topOffset = 0;
}

function divDragHover(event) {
	// only if dragging
	if(event.which != 1)
		return;
	
	// remove all placeholders
	divDragRemovePlaceholders();
	
	// create a new placeholder
	var element = event.currentTarget;
	var placeholder = document.createElement("div");
	placeholder.setAttribute("class", "divDrag_empty");
	
	// determine where to insert the new placeholder
	if(element == divDrag.element)
		divDrag.parent.appendChild(placeholder);
	else {
		//alert(divDrag.parent);
		//alert(placeholder);
		//alert(element);
		divDrag.parent.insertBefore(placeholder, element);
	}
}


function divDragRemovePlaceholders() {
	if(null == divDrag.parent)
		return;
	
	var nodes = divDrag.parent.childNodes;
	for(var i = 0; i < nodes.length; i++) {
		if((nodes[i].nodeName == "DIV") && (nodes[i].getAttribute("class") == "divDrag_empty"))
			divDrag.parent.removeChild(nodes[i]);
	}
}

function divDragNewParent(element) {
	// stop here if not dragging or if parent stays the same
	if((event.which != 1) || (divDrag.parent == element))
		return;
	
	// prevent dropping of a channel that is already in the other group
	if(((element.id == "channels_main") && (channels_main[divDrag.element.title])) || ((element.id == "channels_two") && (channels_two[divDrag.element.title]))) {
		for(var i = 0; i < element.childNodes.length; i++) {
			if(element.childNodes[i].title == divDrag.element.title) {
				divDrag.duplicateChannel = element.childNodes[i];
				divDrag.duplicateChannel.setAttribute("class", "divDrag_item divDrag_alert");
				setTimeout("divDrag.duplicateChannel.setAttribute('class', 'divDrag_item')", 4000);
				return;
			}
		}
	}
	
	// clean up old parent
	divDragRemovePlaceholders();
	divDrag.parent.parentNode.setAttribute("class", "channels_assigned_fix");
	var theChannelElem = divDrag.parent.removeChild(divDrag.element);
	divDrag.oldParent = divDrag.parent;
	
	// style new parent
	divDrag.parent = element;
	divDrag.parent.parentNode.setAttribute("class", "channels_assigned_fix hovermark");
	divDrag.parent.appendChild(theChannelElem);
	divDrag.topOffset = Math.abs(divDrag.topOffsetChannels - divDrag.parent.scrollTop);
	
	// add a placeholder
	var placeholder = document.createElement("div");
	placeholder.setAttribute("class", "divDrag_empty");
	divDrag.parent.appendChild(placeholder);
}









function showFilter(index) {
	var parentdiv = document.getElementById("filters");
	if(!parentdiv)
		return;
	
	var hash = showFilters[index];
	
	// create element and add it to the div
	var div = document.createElement("div");
	div.setAttribute("id", "filterSetting_" + index);
	
	var lang = '';
	for(var key in hash)
		lang += "|" + key + "=" + hash[key];
	
	div.setAttribute("lang", lang);
	div.setAttribute("class", "divDrag_item");
	div.setAttribute("onmouseover", "divDragHover(event)");
	
	var img = document.createElement("img");
	img.setAttribute("class", "removeknob");
	img.setAttribute("src", "Images/removeKnob.png");
	img.setAttribute("alt", "x");
	img.setAttribute("onclick", "removeFilter(this.parentNode)");
	div.appendChild(img);
	
	var text = document.createElement("span");
	text.innerHTML = hash["string"];
	text.setAttribute("class", "divDrag_titlespan");
	text.setAttribute("onmousedown", "divDragDown(this.parentNode, event)");
	text.setAttribute("ondblclick", "addFilter(" + index + ")");
	div.appendChild(text);
	
	showFilterDetails(div, hash);
	
	parentdiv.appendChild(div);
}

function showFilterDetails(obj, hash) {
	if(obj) {
		// remove old detail-info
		if("filter_info" == obj.lastChild.getAttribute("class"))
			obj.removeChild(obj.lastChild);
		
		// add new details
		var info = document.createElement("span");
		info.setAttribute("class", "filter_info");
		
		if(hash["channel"] && (hash["channel"] != 0)) {
			var channel = document.createElement("img");
			channel.setAttribute("src", "Images/AirWaves.png");
			channel.setAttribute("alt", "Sender");
			info.appendChild(channel);
			if("channels_main" == hash["channel"])
				var chan = document.createTextNode("Hauptgruppe");
			else if("channels_two" == hash["channel"])
				var chan = document.createTextNode("Nebengruppe");
			else
				var chan = document.createTextNode(hash["channel"]);
			info.appendChild(chan);
		}
		if(hash["mark"]) {
			var mark = document.createElement("img");
			mark.setAttribute("src", "Images/MiniMarker.png");
			mark.setAttribute("alt", "Marker");
			info.appendChild(mark);
		}
		if(hash["setAlert"]) {
			var clock = document.createElement("img");
			clock.setAttribute("src", "Images/AlarmOnMini.png");
			clock.setAttribute("alt", "Alarm");
			info.appendChild(clock);
		}
		obj.appendChild(info);
	}
}


// shows a sheet with the values of one filter
var editingFilter = -1;
var filterSheetShown = false;
function addFilter(index) {
	var form = document.getElementById("filters_form");
	
	if(index >= 0) {
		editingFilter = index;
		var props = showFilters[index];
		
		form.elements["filter_string"].value = props["string"];
		setFilterOnlyInChannel(props["channel"]);
		form.elements["filter_only_title"].checked = props["title_only"];
		form.elements["filter_mark_show"].checked = props["mark"];
		form.elements["filter_set_alert"].checked = props["setAlert"];
	}
	else {
		form.elements["filter_string"].value = '';
		setFilterOnlyInChannel(0);
		form.elements["filter_only_title"].checked = false;
		form.elements["filter_mark_show"].checked = true;
		form.elements["filter_set_alert"].checked = false;
	}
	
	form.elements["filter_string"].focus();
	filterSheetShown = true;
	showSheet("filters_sheet");
}


// sets properties for a filter from the values on the sheet
var filtersHaveChanged = false;
function setNewFilter() {
	var form = document.getElementById("filters_form");
	var hash = new Object();
	
	if(form.elements["filter_string"].value.length <= 1) {
		FernsehPlugin.beep();
		form.elements["filter_string"].value = "[Suchtext]";
		form.elements["filter_string"].focus();
		return;
	}
	
	hash["string"] = form.elements["filter_string"].value;
	hash["channel"] = form.elements["filter_only_channel"].value;
	hash["title_only"] = form.elements["filter_only_title"].checked;
	hash["mark"] = form.elements["filter_mark_show"].checked;
	hash["setAlert"] = form.elements["filter_set_alert"].checked;
	
	filtersHaveChanged = true;
	
	// edit existing filter
	if(editingFilter >= 0 && showFilters[editingFilter]) {
		var obj = document.getElementById("filterSetting_" + editingFilter);
		var lang = '';
		for(var key in hash)
			lang += "|" + key + "=" + hash[key];
		
		obj.setAttribute("lang", lang);
		obj.firstChild.nextSibling.innerHTML = hash["string"];
		showFilterDetails(obj, hash);
		
		showFilters[editingFilter] = hash;
	}
	
	// add a new one
	else {
		var arrlen = showFilters.push(hash);
		showFilter(arrlen - 1);
	}
	
	hideNewFilterSheet();
}

var filterelementToRemove = null;
function removeFilter(obj) {
	var parent = obj.parentNode;
	if(!parent || filterSheetShown)
		return;
	
	// show poof
	var event = window.event;
	showPoof(event.x, event.y);
	
	// remove it (and set filtersHaveChanged to true!)
	filtersHaveChanged = true;
	filterelementToRemove = obj;
	obj.style.opacity = 0;
	
	setTimeout("document.getElementById('filters').removeChild(filterelementToRemove)", 500);
	setTimeout("filterelementToRemove = null;", 520);
}

function saveFilters() {
	var nodes = document.getElementById("filters").childNodes;
	showFilters = new Array();
	for(var m = 0; m < nodes.length; m++) {
		if(nodes[m].getAttribute("class") == "divDrag_item") {
			var filterhash = new Object();
			
			// attributes are stored in the divs lang-tag. retrieve them
			var attributes = nodes[m].lang.split("|");
			var attr = new Object();
			for (var n = 0; n < attributes.length; n++)
			{
				var tmp = attributes[n].split("=");
				
				// this should never happen, but anyway
				if (tmp.length != 2) continue;
				
				attr[tmp[0]] = tmp[1];
			}
			filterhash["string"] = attr["string"];
			filterhash["channel"] = (attr["channel"] != 0) ? attr["channel"] : 0;
			filterhash["title_only"] = (attr["title_only"] == "true") ? true : false;
			filterhash["mark"] = (attr["mark"] == "true") ? true : false;
			filterhash["setAlert"] = (attr["setAlert"] == "true") ? true : false;

			showFilters.push(filterhash);
		}
	}
	
	widget.setPreferenceForKey(Serialize(showFilters), "show_filters");
}

function setFilterOnlyInChannel(channel) {
	var obj = document.getElementById("filter_only_channel");
	var elements = obj.options;
	if(!channel)
		channel = 0;
	
	for(var i = 0; i < elements.length; i++) {
		if(elements[i].value == channel) {
			elements[i].selected = true;
			setFilterOnlyInChannelText(elements[i].innerHTML);
		}
		else
			elements[i].selected = false;
	}
}

function setFilterOnlyInChannelText(text) {
	var obj = document.getElementById("filter_only_channel_cover");
	obj.innerHTML = (text.substr(0, 3) == "in ") ? text : ((text.substr(5, 6) == "gruppe") ? "in der " + text : "auf " + text);
}



// Sheet Animation

var sheetAnim = { obj:null, start:null, stop:null, time:300, to:0, size:146 }		// size must be the size of the inner sheet (CSS)
function showSheet(id) {
	if(sheetAnim.to == sheetAnim.size)
		return;
	
	var obj = document.getElementById(id);
	sheetAnim.obj = obj.parentNode;
	
	// set animation-variables
	var now = (new Date()).getTime();
	sheetAnim.start = now;
	sheetAnim.stop = sheetAnim.start + sheetAnim.time;
	sheetAnim.to = sheetAnim.size;
	setTimeout("animateSheet();", 10);
}

function animateSheet() {
	var now = (new Date()).getTime();
	if (now < sheetAnim.stop)
	{
		var delta = (now - sheetAnim.start) / sheetAnim.time;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var size = (sheetAnim.to < 1) ? (sheetAnim.size - (sheetAnim.size * factor)) : (sheetAnim.to * factor);
		debug(size);
		sheetAnim.obj.style.height = size + "px";
		
		setTimeout("animateSheet();", 10);
	} else {
		sheetAnim.obj.style.height = sheetAnim.to + "px";
		sheetAnim.obj = null;
	}
}

function hideSheet(id) {
	if(sheetAnim.to == 0)
		return;
	
	var obj = document.getElementById(id);
	sheetAnim.obj = obj.parentNode;
	
	var now = (new Date()).getTime();
	sheetAnim.start = now;
	sheetAnim.stop = sheetAnim.start + sheetAnim.time;
	sheetAnim.to = 0;
	setTimeout("animateSheet();", 10);
}

function hideNewFilterSheet() {
	editingFilter = -1;
	filterSheetShown = false;
	hideSheet("filters_sheet");
}






function startEyeTVAndSwitchToPrefs()
{
	document.getElementById("eyetv_start_hint").innerHTML = (useFormac == 1 ? "FormacDVB" : "EyeTV") + " wird gestartet...";
	asTell("activate");

	var channelstest = getEyeTVChannels();
	if ((undefined == channelstest) || (channelstest.length == 0))
	{
		document.getElementById("eyetv_start_hint").innerHTML = "Fehler beim Laden der Sender.<br/>Bitte &uuml;berpr&uuml;fen Sie Ihre Hard- und Software.";
		return;
	}

	document.getElementById("eyetv_start_hint").innerHTML = "Senderzuweisungen werden geladen...";
	checkEyeTV();
	switchToPrefSection("eyetv_form");
}

function guessIndexForChannel(channels, chan)
{
	// all names in "channels" are assumed to be lowercase and not to contain spaces for performance reasons!
	var guessname = chan.toLowerCase();
	guessname = guessname.replace(/ /, "");

	// a few hard-coded channel names
	if (guessname == "prosieben") guessname = "pro7";
	if (guessname == "wdr") guessname = "west";
	if (guessname == "br") guessname = "bayern";
	if (guessname == "hr") guessname = "hessen";
	
	//alert (channels + "\n" + guessname);
	
	for (k = 0; k < channels.length; k++)
	{
		//if (channels[k] == guessname) alert(guessname + " >> " + channels[k]);
		if (channels[k] == guessname) return k;
	}
	
	// in case we're dealing with dvb
	if (guessname == "daserste") guessname = "ard"; // The DVB name for "ARD" is "Das Erste"
	for (k = 0; k < channels.length; k++)
	{
		//if (channels[k] == guessname) alert(guessname + " >> " + channels[k]);
		if (channels[k] == guessname) return k;
	}
	
	//alert("still looking for match for " + guessname);
	
	var bestIndex = -1;
	var bestNumMatches = 0;
	
	for (k = 0; k < channels.length; k++)
	{
		var numMatches = 0;
		var theChan = channels[k];
		while ((numMatches < theChan.length) && (numMatches < guessname.length))
		{
			if (theChan.substr(numMatches, 1) == guessname.substr(numMatches,1)) numMatches++;
			else break;
		}
		if (numMatches > bestNumMatches)
		{
			bestIndex = k;
			bestNumMatches = numMatches;
		}
	}
	if (bestNumMatches >= 3) return bestIndex;

	var reverseChannels = new Array();
	for (k = 0; k < channels.length; k++)
	{
		reverseChannels.push(reverseString(channels[k]));
	}
	
	bestIndex = -1;
	bestNumMatches = 0;
	var reverseChannel = reverseString(guessname);
	
	for (k = 0; k < channels.length; k++)
	{
		var numMatches = 0;
		var theChan = reverseChannels[k];
		while ((numMatches < theChan.length) && (numMatches < reverseChannel.length))
		{
			if (theChan.substr(numMatches, 1) == reverseChannel.substr(numMatches,1)) numMatches++;
			else break;
		}
		if (numMatches > bestNumMatches)
		{
			bestIndex = k;
			bestNumMatches = numMatches;
		}
	}

	if (bestNumMatches >= 3) return bestIndex;
	else return -1;
}

function reverseString(forward)
{
	var reverse = "";
	for (i = forward.length-1; i >= 0; i--)
	{
		reverse += forward.substring(i, 1);
	}
	return reverse;
}

// takes an object to blur OR the name of an object to blur
function blurItem(name) {
	if(typeof(name) == "string")
		obj = document.getElementById(name);
	else if(typeof(name) == "object")
		obj = name;
	
	obj.style.opacity = 0.4;
}

// takes an object to blur OR the name of an object to blur
function unblurItem(name) {
	if(typeof(name) == "string")
		obj = document.getElementById(name);
	else if(typeof(name) == "object")
		obj = name;
	
	obj.style.opacity = 1;
}



/*
 *******************
 * onShow + onHide *
 *******************
 */

function onShow()
{
	networkErrorOccurred = false;
	weMayCache = true;		// allows caching activities
	
	
	if (refreshBlocked)
	{
		if (releaseRefreshBlock)
		{
			refreshBlocked = false;
		}
		checkBTAvailability();
		return;
	}
	
	if ((getListingTime() == "jetzt") && (!isSearchResult) && (!isCollapsed())) updateTVListing();
	checkBTAvailability();
}

function onHide() {
	weMayCache = false;		// aborts all caching activities
	stopProgressBar();
	stopCacheIndicator();
}

function cleanUp() {
	return;
	if(window.widget) {
		widget.setPreferenceForKey(null, "channel");
		widget.setPreferenceForKey(null, "channelkind");
		widget.setPreferenceForKey(null, "channels_main");
		widget.setPreferenceForKey(null, "channels_two");
		widget.setPreferenceForKey(null, "day");
		widget.setPreferenceForKey(null, "eyetvChannels");
		widget.setPreferenceForKey(null, "eyetvEnabled");
		widget.setPreferenceForKey(null, "growlSupport");
		widget.setPreferenceForKey(null, "hour");
		widget.setPreferenceForKey(null, "reminder");
		widget.setPreferenceForKey(null, "showShortDesc");
		widget.setPreferenceForKey(null, "windowX");
		widget.setPreferenceForKey(null, "windowY");
		widget.setPreferenceForKey(null, "numEntriesPerPage");
		widget.setPreferenceForKey(null, "numDaysToPrecache");
	}
}




/*
 ***************
 * Drawer	   *
 ***************
 */

var drawer = { timer:null, current:0, to:44, contentpadding:28 };

function resizeDrawer() {
	/*
	das erzwungen 0px hohe element 'drawer' wird beim einblenden auf die Grösse vom Text enthaltenden 'drawercontent' angepasst oder auf 0 zurückgestellt
	*/
	var drawercontent = document.getElementById('drawercontent');
	
	if(drawer.timer) {
		clearInterval(drawer.timer);
		drawer.timer = null;
	}
	
	drawer.to = document.defaultView.getComputedStyle(drawercontent).getPropertyValue('height').replace(/px/, '') *1 + drawer.contentpadding;
	
	//alert('resizeDrawer(): starting to resize drawer from ' + drawer.current + ' to ' + drawer.to);
	drawer.timer = setInterval("animateDrawer()", 30);
	animateDrawer();
}

function hideDrawer() {
	if(drawer.timer) {
		clearInterval(drawer.timer);
		drawer.timer = null;
	}
	
	if(drawer.current == 0) return;
	
	var drawerDiv = document.getElementById('drawer');
	var superParentDiv = document.getElementById('superParentDiv');
	
	if(window.widget)
		window.resizeBy(0, -drawer.current);
	superParentDiv.style.bottom = '0px';	// keep bottom of main table away from growing drawer
	drawerDiv.style.height = '0px';			// set drawer to desired size
	
	drawer.current = 0;
	
	document.getElementById('toggledrawer').style.backgroundImage = "url(Images/drawerDown.png)";
}

function toggleDrawer() {
	/*
	das erzwungen 0px hohe element 'drawer' wird beim einblenden auf die Grösse vom Text enthaltenden 'drawercontent' angepasst oder auf 0 zurückgestellt
	*/
	var drawercontent = document.getElementById('drawercontent');
	
	if(drawer.timer) {
		clearInterval(drawer.timer);
		drawer.timer = null;
	}
	
	if(drawer.current > 0)
	{
		drawer.to = 0;
		/*if (null != previousShowObject)
		{
			previousShowObject.setAttribute('class', previousShowClass);
			previousShowObject = null;
		}*/

	} else
		drawer.to = document.defaultView.getComputedStyle(drawercontent).getPropertyValue('height').replace(/px/, '') *1 + drawer.contentpadding;
	
	//alert('toggleDrawer(): starting to resize drawer from ' + drawer.current + ' to ' + drawer.to);
	drawer.timer = setInterval("animateDrawer()", 30);
	animateDrawer();
}

function animateDrawer() {
	var drawerDiv = document.getElementById('drawer');
	var superParentDiv = document.getElementById('superParentDiv');
	var diff = drawer.to - drawer.current;
	
	var by = (diff > 0) ? Math.ceil(diff * 0.4) : Math.floor(diff * 0.4);
	var to = by + drawer.current;
	drawer.current = to;
	
	if(diff != 0) {
		//alert('resizing to ' + to + 'px');
		drawerDiv.style.height = to + 'px';				// grow drawerbox
		superParentDiv.style.bottom = to + 'px';		// keep bottom of main table away from growing drawer
		if(window.widget)
			window.resizeBy(0, by);
	}
	else {
		clearInterval(drawer.timer);
		drawer.timer = null;
		document.getElementById('toggledrawer').style.backgroundImage = (drawer.current == 0) ? "url(Images/drawerDown.png)" : "url(Images/drawerUp.png)";
	}
}


/*
 * ProgressBar
 */

var progressbar = { preloaded:false, timer:null, index:0 }

function preloadImages() {
	if(! progressbar.preloaded) {
		var ImgArr = new Array();
		for(i = 0; i < 10; i++) {
			ImgArr[i] = new Image();
			ImgArr[i].src = "Images/progressBar" + i + ".png"
		}
	}
	progressbar.preloaded = true;
}
function startProgressBar() {
	if (progressbar.timer != null) return;
	preloadImages();
	document.getElementById('progressbar').style.display = 'block';
	progressbar.timer = setInterval("animateProgressBar()", 40);
}

function stopProgressBar() {
	document.getElementById('progressbar').style.display = 'none';
	clearInterval(progressbar.timer);
	progressbar.timer = null;
}

function animateProgressBar() {
	if(! progressbar.index)
		progressbar.index = 10;
	progressbar.index--;
	if(progressbar.index < 0)
		progressbar.index = 9;
	
	document.getElementById('progressbar').style.backgroundImage = "url(Images/progressBar" + progressbar.index + ".png)";
	//alert("animateprogressbar");
}

var cachingIndicator = { interval:null, step:0 };
var cachingImagesLoaded = false;

function startCacheIndicator() {
	stopCacheIndicator();
	var obj = document.getElementById("cacheindicator");
	
	// preload images
	if(!cachingImagesLoaded) {
		for(var i = 0; i < 12; i++) {
			img = new Image();
			img.src = "Images/progress" + i + ".png";
		}
		cachingImagesLoaded = true;
	}
	
	obj.style.paddingLeft = "17px";
	// obj.style.backgroundImage = "url(Images/progress0.png)";
	// cachingIndicator.step = 0;
	animateCacheIndicator();
	
	cachingIndicator.interval = setInterval("animateCacheIndicator()", 80);
	setCacheIndicatorText("lade Daten");
}

function stopCacheIndicator() {
	var obj = document.getElementById("cacheindicator");
	
	if(cachingIndicator.interval) {
		clearInterval(cachingIndicator.interval);
	}
	cachingIndicator.interval = null;
	
	obj.style.backgroundImage = "url()";
	obj.style.paddingLeft = "1px";
	setCacheIndicatorText("");
}

function animateCacheIndicator() {
	var obj = document.getElementById("cacheindicator");
	obj.style.backgroundImage = "url(Images/progress" + cachingIndicator.step + ".png)";
	
	cachingIndicator.step++;
	cachingIndicator.step = (cachingIndicator.step > 11) ? 0 : cachingIndicator.step;
	//alert("animatecacheindicator");
}

function setCacheIndicatorText(text) {
	document.getElementById("cacheindicator").innerHTML = text;
}

/*
	the Poof
 */
 function showPoof(x, y) {
 	if(document.getElementById("poof"))
 		document.removeChild(document.getElementById("poof"));
 	
 	// create the poof
 	var my_x = x + 10;
 	var my_y = y - 15;
 	var div = document.createElement("canvas");
 	div.setAttribute("id", "poof");
 	div.setAttribute("style", "top:" + my_y + "px; left:" + my_x + "px;");
 	
 	document.appendChild(div);
 	document.poofSound.Play();
 	
 	// make sure it animates
 	animatePoof(1);
 	setTimeout("animatePoof(2)", 100);
 	setTimeout("animatePoof(3)", 200);
 	setTimeout("animatePoof(4)", 300);
 	setTimeout("animatePoof(5)", 400);
 	
 	// make sure we remove it
  	setTimeout("document.removeChild(document.getElementById('poof'))", 500);
}
 
function animatePoof(step)
{
	var img = new Image();
	img.src = "/System/Library/CoreServices/Dock.app/Contents/Resources/poof.png";
	var div = document.getElementById("poof");
	var context = div.getContext("2d");
	context.clearRect(0, 0, 30, 30);
	context.drawImage(img, 0, (step-1)*128, 128, 128, 0, 0, 30, 30);
}
 
function blendFromTo(from_id, to_id) {
	var from = document.getElementById(from_id);
	var to = document.getElementById(to_id);
	
	if(from && to) {
		from.style.display = 'none';
		to.style.display = 'block';
	}
}



/*
 **************************
 * Collapse/Expand Widget *
 **************************
 */
 
function isCollapsed()
{
	return (window.innerHeight < 100);
}

var standardExpandCollapseTime = 800;
var longExpandCollapseTime = 4000;
var expandCollapseTime;
var toHideObjectsBasic = new Array('flip', 'toggledrawer', 'shortcutscover', 'pages', 'logo_front', 'resize', 'badges');
var toHideObjects;
var widgetAnim = { width:window.innerWidth, expandedHeight:null, collapsedHeight:56, removeClipping:null, startsize:null, animateIn:null, stop:null, start:null };

function toggleWidget(event)
{
	toHideObjects = copyArray(toHideObjectsBasic);
	if (FernsehPlugin.canUseBluetooth()) toHideObjects.push('bluetoothSwitch');
	if(event && event.shiftKey) {
		expandCollapseTime = longExpandCollapseTime;
	}
	else {
		expandCollapseTime = standardExpandCollapseTime;
	}
	
	hideDrawer();
	stopProgressBar();
	document.getElementById("flip").style.display = "none";
	var height = window.innerHeight;
	
	widgetAnim.width = window.innerWidth;
	widgetAnim.startsize = height;
	widgetAnim.start = (new Date).getTime();
	widgetAnim.stop = widgetAnim.start + expandCollapseTime;
	
	// collapse
	if(height > 100) {
		hideHelp();
		
		document.getElementById('myScrollBar').style.display = 'none';

		widgetAnim.expandedHeight = height;
		widgetAnim.animateIn = false;
		widgetAnim.finalsize = widgetAnim.collapsedHeight;
		widgetAnim.removeClipping = false;
		
		animateWindowTo();
	}
	
	// expand
	else {
		if(widgetAnim.expandedHeight < 100)
			widgetAnim.expandedHeight = 349;
		
		for(i = 0; i < toHideObjects.length; i++)
			document.getElementById(toHideObjects[i]).style.display = 'block';
		
		widgetAnim.animateIn = true;
		widgetAnim.finalsize = widgetAnim.expandedHeight;
		widgetAnim.removeClipping = true;
		
		document.getElementById('superParentDiv').style.bottom = (widgetAnim.expandedHeight - widgetAnim.collapsedHeight) + 'px';
		window.resizeTo(widgetAnim.width, widgetAnim.expandedHeight);
		
		animateWindowTo();
	}
}

function animateWindowTo()
{
	var now = (new Date()).getTime();
	if (now < widgetAnim.stop)
	{
		var delta = (now - widgetAnim.start) / expandCollapseTime;
		var factor = ((delta * delta) * 3.0) - ((delta * delta * delta) * 2.0);
		var size = (widgetAnim.startsize * (1-factor)) + (factor*widgetAnim.finalsize);
		
		document.getElementById('superParentDiv').style.bottom = (widgetAnim.expandedHeight - size) + 'px';
		//alert(now - widgetAnim.start);
		// we have to fiddle with the clipping since the images are overlapping. 25 pixel is the total amount to clip the top- (18) and bottompart (7)
		if((size - widgetAnim.collapsedHeight) < 25) {
			var topclip;
			var bottomclip;
			topclip = 26 + Math.ceil((size - widgetAnim.collapsedHeight) / 3 * 2);
			bottomclip = 7 - Math.ceil((size - widgetAnim.collapsedHeight) / 3);
			
			document.getElementById('titleleft').style.clip = "rect(0px,20px," + topclip + "px,0px)";
			document.getElementById('titleright').style.clip = "rect(0px,20px," + topclip + "px,0px)";
			document.getElementById('controlbarleft').style.clip = "rect(" + bottomclip + "px,20px,37px,0px)";
			document.getElementById('controlbar').style.clip = "rect(" + bottomclip + "px," + (widgetAnim.width - 40) + "px,37px,0px)";
			document.getElementById('controlbarright').style.clip = "rect(" + bottomclip + "px,20px,37px,0px)";
		}
		else if(widgetAnim.removeClipping) {
			document.getElementById('titleleft').style.clip = null;
			document.getElementById('titleright').style.clip = null;
			document.getElementById('controlbarleft').style.clip = null;
			document.getElementById('controlbar').style.clip = null;
			document.getElementById('controlbarright').style.clip = null;
			widgetAnim.removeClipping = false;
		}
		// -------------
		
		for(i = 0; i < toHideObjects.length; i++)
			document.getElementById(toHideObjects[i]).style.opacity = widgetAnim.animateIn ? factor : (1-factor);
		
		setTimeout("animateWindowTo()", 10);
	}
	
	// last run before animation stops
	else {
		window.resizeTo(widgetAnim.width, widgetAnim.finalsize);
		document.getElementById('superParentDiv').style.bottom = '0px';
		
		// finalize display/opacity
		for(i = 0; i < toHideObjects.length; i++) {
			document.getElementById(toHideObjects[i]).style.opacity = widgetAnim.animateIn ? 1 : 0;
			document.getElementById(toHideObjects[i]).style.display = widgetAnim.animateIn ? "block" : "none";
		}
		
		// finish up clipping
		if(!widgetAnim.animateIn) {
			document.getElementById('titleleft').style.clip = "rect(0px,20px,26px,0px)";
			document.getElementById('titleright').style.clip = "rect(0px,20px,26px,0px)";
			document.getElementById('controlbarleft').style.clip = "rect(7px,20px,37px,0px)";
			document.getElementById('controlbar').style.clip = "rect(7px," + (widgetAnim.width - 40) + "px,37px,0px)";
			document.getElementById('controlbarright').style.clip = "rect(7px,20px,37px,0px)";
		}
		else {
			document.getElementById('titleleft').style.clip = null;
			document.getElementById('titleright').style.clip = null;
			document.getElementById('controlbarleft').style.clip = null;
			document.getElementById('controlbar').style.clip = null;
			document.getElementById('controlbarright').style.clip = null;
			
			document.getElementById('myScrollBar').style.display = 'block';
			calculateAndShowThumb(document.getElementById('content'));
			if ((getListingTime() == "jetzt") && (!isSearchResult) && (!isQuickAccessSearch)) updateTVListing();
		}
	}
}

function assureExpanded()
{
	if (isCollapsed()) toggleWidget();
}




/*
 ************
 *  Dialog  *
 ************
 */


var dialogShown = false;
var dialogAnimation = { duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null };

function showDialog(showText, button1Text, button1Handle, button2Text, button2Handle) {
	removeDialog();
	
	var div = document.createElement("div");
	div.setAttribute("id", "theOnlyDialog");
	div.setAttribute("class", "dialogDiv");
	div.innerHTML = showText ? showText : "kein Text angegeben";
	
	if(button1Text) {
		var buttonbar = document.createElement("div");
		buttonbar.setAttribute("class", "dialogButtonBar");
		
		var b1 = document.createElement("div");
		b1.setAttribute("class", "dialog-button dialog-button-up");
		buttonbar.appendChild(b1);
		createDialogButton(b1, button1Text, button1Handle, 80);
	}
	
	if(button2Text) {
		var b2 = document.createElement("div");
		b2.setAttribute("class", "dialog-button dialog-button-up");
		buttonbar.appendChild(b2);
		createDialogButton(b2, button2Text, button2Handle, 80);
	}
	
	div.appendChild(buttonbar);
	document.getElementById("parentDiv").appendChild(div);
	blendDialogIn();
	stopProgressBar();
	stopCacheIndicator();
	calculateAndShowThumb(document.getElementById('content'));
}

function removeDialog() {
	if(dialogShown)
		(document.getElementById("parentDiv")).removeChild(document.getElementById("theOnlyDialog"));
	
	dialogShown = false;
}

function blendDialogIn() {
	if(!dialogShown) {
		if (dialogAnimation.timer != null) {
			clearInterval(dialogAnimation.timer);
			dialogAnimation.timer = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		dialogAnimation.duration = 300;
		dialogAnimation.starttime = starttime;
		dialogAnimation.firstElement = document.getElementById("theOnlyDialog");
		dialogAnimation.timer = setInterval("animate2();", 13);
		dialogAnimation.from = dialogAnimation.now;
		dialogAnimation.to = 1.0;
		animate2();
		dialogShown = true;
	}
}


function blendDialogOut() {
	if(dialogShown) {
		
		// fade out the info button
		if (dialogAnimation.timer != null)
		{
			clearInterval (dialogAnimation.timer);
			dialogAnimation.timer	= null;
		}

		var starttime = (new Date).getTime() - 13;

		dialogAnimation.duration = 300;
		dialogAnimation.starttime = starttime;
		dialogAnimation.firstElement = document.getElementById("theOnlyDialog");
		dialogAnimation.timer = setInterval("animate2();", 13);
		dialogAnimation.from = dialogAnimation.now;
		dialogAnimation.to = 0.0;
		animate2();
		//dialogShown = false;
	}
}

// animate-function blow used
function animate2() {
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time - dialogAnimation.starttime, 0, dialogAnimation.duration);

	if (T >= dialogAnimation.duration) {
		clearInterval(dialogAnimation.timer);
		dialogAnimation.timer = null;
		dialogAnimation.now = dialogAnimation.to;
		
		// clean up after blending out
		if(dialogAnimation.to == 0.0)
			removeDialog();
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / dialogAnimation.duration));
		dialogAnimation.now = computeNextFloat (dialogAnimation.from, dialogAnimation.to, ease);
	}

	dialogAnimation.firstElement.style.opacity = dialogAnimation.now;
}




/*
 ************
 * by Apple *
 ************
 */


/*
 * Window-resizing (modified)
 */
 
var lastPos;

function mouseDown(event) {
	var x = event.x + window.screenX;
	var y = event.y + window.screenY;
	
	document.addEventListener("mousemove", mouseMove, true);
	document.addEventListener("mouseup", mouseUp, true);
	lastPos = {x:x, y:y};
	event.stopPropagation();
	event.preventDefault();
}

function mouseMove(event) {
	var myevent = { x:(event.x < 290 ? 290 : event.x), y:(event.y < 280 ? 280 : event.y) };
	var screenX = myevent.x + window.screenX;
	var screenY = myevent.y + window.screenY;
	
	window.resizeBy(screenX - lastPos.x, screenY - lastPos.y);
	if(document.getElementById("helpdiv").style.display == 'block')
		calculateAndShowThumb(document.getElementById("helpdiv"));
	else
		calculateAndShowThumb(document.getElementById("content"));

	lastPos = {x:screenX, y:screenY};
	event.stopPropagation();
	event.preventDefault();
}

function mouseUp(event) {
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true); 
	event.stopPropagation();
	event.preventDefault();
	
	// resize Drawer if it is visible
	if(drawer.current > 0) {
		resizeDrawer();
	}
	
	if(document.getElementById('helpdiv').style.display == 'block')
		calculateAndShowThumb(document.getElementById("helpdiv"));
	else
		calculateAndShowThumb(document.getElementById("content"));
		
	// save in Prefs??
	if(window.widget) {
		widget.setPreferenceForKey(window.innerWidth, "windowX");
		widget.setPreferenceForKey(window.innerHeight, "windowY");
		//alert("Saving size: " + window.innerWidth + ":" + window.innerHeight);
	}
}



/*
 * i-Button
 */

var flipShown = false;
var animation = { duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null };

function mousemove(event) {
	if(!flipShown) {
		if (animation.timer != null) {
			clearInterval(animation.timer);
			animation.timer = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}


function mouseexit(event) {
	if(flipShown) {
		
		// fade out the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer	= null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() {
	var T;
	var ease;
	var time = (new Date).getTime();
	
	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3(a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
	return from + (to - from) * ease;
}


// these functions are called when the info button itself receives onmouseover and onmouseout events (by Apple)

function enterflip(event) {
	if (document.getElementById('flip').opacity < 0.1) return;
	document.getElementById("fliprollie").style.display = "block";
}

function exitflip(event) {
	document.getElementById("fliprollie").style.display = "none";
}

